indexing
   description: "Initialize variable used across the program"
   "and how to access them."
   status: "Free according to the GPL license (see COPYING)"
   date: "$Date$"
   revision: "$Revision$"
   author: "Mark Arrasmith <arrasmith@math.twsu.edu> and Miron Brezuleanu"
   

class CONFIGURATION
   
creation
   make
   
feature
   
   make is
      do
	 width := 400
	 height := 300
	 -- initialize complex window for the fractal
	 !!zoom.make(1,1,1,8)
	 zoom.put(-2.5,1,1)
	 zoom.put(-1.875,1,2)
	 zoom.put(-2.5,1,3)
	 zoom.put(1.875,1,4)
	 zoom.put(2.5,1,5)
	 zoom.put(1.875,1,6)
	 zoom.put(2.5,1,7)
	 zoom.put(-1.875,1,8)
	 !!old_zoom.make(1,1,1,8)
	 old_zoom.from_collection2(zoom)
	 -- create transform constants
	 calculate_transform
	 -- set initial fractal type/params/window
	 type := "mandel"
	 image_path := ""
	 map_name := "(untitled)"
	 file_name := "(untitled)"
	 color_outside := "iteration"
	 color_inside := "max"
	 lyapunov_pattern := "1001101010"
	 total := 250
	 colors := 250
	 dump := 4
	 do_julia := False
	 julia_x := 0.5
	 julia_y := 0.5
	 color_x := 0.0
	 color_y := 0.0
	  end
   
feature -- transforms and secondary names
   
   calculate_transform is
      do
	  a := (x3 - x2)/width
	  b := (x1 - x2)/height
	  c := x2
	  d := (y3 - y2)/width
	  e := (y1 - y2)/height
	  f := y2
	  g := (x2 + x4 - x1 - x3)/(width*height)
	  h := (y2 + y4 - y1 - y3)/(width*height)
	  end
   
   reinitialize_window is
      do
	  zoom.resize(1,1,1,8)
	  -- create transform constants
	  calculate_transform
	  -- set initial params
	  total := 250
	  dump := 4
	  end

   start_julia is
      do
	  old_zoom.from_collection2(zoom)
	  zoom.resize(1,1,1,8)
	  calculate_transform
	  end

   end_julia is
      do
	  zoom.from_collection2(old_zoom)
	  calculate_transform
	  end
	  
   
   inc_zoom is
      do
	    zoom.resize(1,zoom.count1 + 1,1,8)
	  end

   dec_zoom is
      do
	    if zoom.count1 > 1 then
		  zoom.resize(1,zoom.count1 - 1,1,8)
		end
	  end

   load_zoom is
      do
		zoom.resize(1,2,1,8)
	  end
   
   x1: DOUBLE is
      do
		Result := zoom.item(zoom.count1,1)
	  end

   y1: DOUBLE is
      do
	  	Result := zoom.item(zoom.count1,2)
	  end

   x2: DOUBLE is
      do
		Result := zoom.item(zoom.count1,3)
	  end

   y2: DOUBLE is
      do
	  	Result := zoom.item(zoom.count1,4)
	  end

   x3: DOUBLE is
      do
		Result := zoom.item(zoom.count1,5)
	  end

   y3: DOUBLE is
      do
	  	Result := zoom.item(zoom.count1,6)
	  end

   x4: DOUBLE is
      do
		Result := zoom.item(zoom.count1,7)
	  end

   y4: DOUBLE is
      do
	  	Result := zoom.item(zoom.count1,8)
	  end

feature -- setter commands

   set_type(nv: STRING) is
      do
	  type := nv
	  end
	  
   set_total(nv: INTEGER) is
      do
	  total := nv
	  end
	  
   set_colors(nv: INTEGER) is
      do
	  colors := nv
	  end
	  
	  
   set_dump(nv: INTEGER) is
      do
	  dump := nv
	  end
	  
   set_color_outside(nv: STRING) is
      do
	  color_outside := nv
	  end
	  
   set_color_inside(nv: STRING) is
      do
	  color_inside := nv
	  end
	  
   set_width(nv: INTEGER) is
      do
	 width := nv
      end
      
   set_height(nv: INTEGER) is
      do
	 height := nv
      end
      
   set_path(nv: STRING) is
      do
	 path := nv
      end
   
   set_x1(nv: DOUBLE) is
      do
	  zoom.put(nv,zoom.count1,1)
	  end
   
   set_x2(nv: DOUBLE) is
      do
	  zoom.put(nv,zoom.count1,3)
	  end
   
   set_x3(nv: DOUBLE) is
      do
	  zoom.put(nv,zoom.count1,5)
	  end

   set_x4(nv: DOUBLE) is
      do
	  zoom.put(nv,zoom.count1,7)
	  end

   set_y1(nv: DOUBLE) is
      do
	  zoom.put(nv,zoom.count1,2)
	  end
   
   set_y2(nv: DOUBLE) is
      do
	  zoom.put(nv,zoom.count1,4)
	  end
   
   set_y3(nv: DOUBLE) is
      do
	  zoom.put(nv,zoom.count1,6)
	  end

   set_y4(nv: DOUBLE) is
      do
	  zoom.put(nv,zoom.count1,8)
	  end

   set_julia_seed_x(nv: DOUBLE) is
      do
	  julia_seed_x := nv
	  end

   set_julia_seed_y(nv: DOUBLE) is
      do
	  julia_seed_y := nv
	  end

   set_color_x(nv: DOUBLE) is
      do
	  color_x := nv
	  end

   set_color_y(nv: DOUBLE) is
      do
	  color_y := nv
      end

   set_do_julia(nv: BOOLEAN) is
      do
	  do_julia := nv
      end

   set_julia_x(nv: DOUBLE) is
      do
	  julia_x := nv
      end

   set_julia_y(nv: DOUBLE) is
      do
	  julia_y := nv
      end

   set_lyapunov_pattern(nv: STRING) is
      do
	  lyapunov_pattern := nv
      end

   set_file_name(nv: STRING) is
      do
	  file_name := nv
      end

   set_map_name(nv: STRING) is
      do
	  map_name := nv
      end

   set_image_path(nv: STRING) is
      do
	  image_path := nv
      end

feature -- attributes
   
   width, height: INTEGER
   a,b,c,d,e,f,g,h: DOUBLE
   colors, total, dump: INTEGER
   type, color_outside, color_inside: STRING
   lyapunov_pattern, file_name, map_name, image_path: STRING
   julia_x,julia_y,color_x,color_y: DOUBLE
   do_julia: BOOLEAN
   zoom,old_zoom: ARRAY2[DOUBLE]

end

