indexing
   description: "What it says: the fractal color functions."
   status: "Free according to the GPL license (see COPYING)"
   date: "$Date$"
   revision: "$Revision$"
   author: "Mark Arrasmith <arrasmith@math.twsu.edu>"
   

class EFRACTAL_COLOR_FUNCTIONS

feature -- Fractal Color Functions

	c_iter(a,b: DOUBLE; iteration: INTEGER): INTEGER is
		-- pixel = iteration
		require
			iteration >= 0
		do
			Result := iteration + 1
		end --c_iteration

	c_real(a,b: DOUBLE; iteration: INTEGER): INTEGER is
		-- pixel = iteration + a
		require
			iteration >= 0
		do
			Result := iteration*(config.colors/24).rounded + ((a*config.colors)/24).rounded.abs
		end --c_real

	c_imag(a,b: DOUBLE; iteration: INTEGER): INTEGER is
		-- pixel = iteration + b
		require
			iteration >= 0
		do
			Result := iteration*(config.colors/24).rounded + ((b*config.colors)/24).rounded.abs
		end --c_imag

	c_times(a,b: DOUBLE; iteration: INTEGER): INTEGER is
		-- pixel = iteration*(a*b)
		require
			iteration >= 0
		do
			Result := iteration * (a*b).rounded.abs + 1
		end --c_times

	c_sum(a,b: DOUBLE; iteration: INTEGER): INTEGER is
		-- pixel = iteration + a + b
		require
			iteration >= 0
		do
			Result := iteration*(config.colors/24).rounded + (((a+b)*config.colors)/24).rounded.abs
		end --c_sum

	c_zmag(a,b: DOUBLE; iteration: INTEGER): INTEGER is
		-- pixel = (a^2 + b^2)*iteration + 1
		require
			iteration >= 0
		do
			Result := ((a*a + b*b)*iteration).rounded + 1
		end --c_zmag

	c_atan(a,b: DOUBLE; iteration: INTEGER): INTEGER is
		-- pixel = iteration + atan(b/a)
		require
			iteration >= 0
		do
			if a = 0 then
				Result := iteration + 90
			else
				Result := iteration + ((b/a).atan*57.29579).rounded.abs
			end
		end --c_atan

	c_taper(a,b: DOUBLE; iteration: INTEGER): INTEGER is
		-- pixel = config.colors - config.colors/(iteration + 1)\
		require
			iteration >= 0
		do
			if iteration.even then
				Result := iteration + (config.colors/24 + a*b).rounded.abs
			else
				Result := iteration + (a*b).rounded.abs
			end
		end --c_taper

end --class EFRACTAL_COLOR_FUNCTIONS
