indexing
   description: "Edit fractal parameters."
   status: "Free according to the GPL license (see COPYING)"
   date: "$Date$"
   revision: "$Revision$"
   author: "Mark Arrasmith <arrasmith@math.twsu.edu> and Miron Brezuleanu"
   
   
class NEW_PARAMS_DIALOG 
   
inherit
   EXG_DIALOG
   STARTUP
   
creation
   make
   
feature
   
   init_dialog is
      do
	 total := config.total
	 dump := config.dump
	 julia_x := config.julia_x
	 julia_y := config.julia_y
	 lyapunov_pattern := config.lyapunov_pattern
      end
   
   commit is
	 -- will write the changes to the fields
      do
	 total := total_adj.value.floor
	 dump := dump_adj.value.floor
	 julia_x := julia_x_adj.text.to_double
	 julia_y := julia_y_adj.text.to_double
	 lyapunov_pattern := lyapunov_pattern_adj.text
	 config.set_total(total)
	 config.set_dump(dump)
	 config.set_julia_x(julia_x)
	 config.set_julia_y(julia_y)
	 config.set_lyapunov_pattern(lyapunov_pattern)
	 commit_ok := True
      end
   
   build_vbox is
      local
	 table: GTK_TABLE
	 label: GTK_LABEL
	 sbutton: GTK_SPIN_BUTTON
      do
	 set_title("Enter Parameter Data:")
	 !!vbox.make(False, 0)	 
	 
	 !!table.make(6, 2, False)
	 
	 !!label.make_with_label("Enter Parameter Values:")
	 label.set_alignment(0.0, 0.5)
	 table.attach2(label, 0, 2, 0, 1)
	 label.show
	 
	 !!label.make_with_label("Iterations: ")
	 label.set_alignment(0.0, 0.5)
	 table.attach2(label, 0, 1, 1, 2)
	 label.show
	 
	 !!total_adj.make(total.to_real, 1.0, 10000.0, 1.0, 100.0, 0.0)
	 !!sbutton.make_with_adjustment(total_adj, 0.5, 0)
	 table.attach2(sbutton, 1, 2, 1, 2)
	 sbutton.show
	 
	 !!label.make_with_label("Bailout: ")
	 label.set_alignment(0.0, 0.5)
	 table.attach2(label, 0, 1, 2, 3)
	 label.show
	 
	 !!dump_adj.make(dump.to_real, 1.0, 2000.0, 1.0, 100.0, 0.0)
	 !!sbutton.make_with_adjustment(dump_adj, 0.5, 0)
	 table.attach2(sbutton, 1, 2, 2, 3)
	 sbutton.show
	 
	 !!label.make_with_label("Julia_X: ")
	 label.set_alignment(0.0, 0.5)
	 table.attach2(label, 0, 1, 3, 4)
	 label.show

	 !!julia_x_adj.make
	 julia_x_adj.set_text(julia_x.to_string_format(18))
	 table.attach2(julia_x_adj, 1, 2, 3, 4)
	 julia_x_adj.show
	 
	 !!label.make_with_label("Julia_Y: ")
	 label.set_alignment(0.0, 0.5)
	 table.attach2(label, 0, 1, 4, 5)
	 label.show

	 !!julia_y_adj.make
	 julia_y_adj.set_text(julia_y.to_string_format(18))
	 table.attach2(julia_y_adj, 1, 2, 4, 5)
	 julia_y_adj.show
	 
	 !!label.make_with_label("Lyapunov Seed: ")
	 label.set_alignment(0.0, 0.5)
	 table.attach2(label, 0, 1, 5, 6)
	 label.show

	 !!lyapunov_pattern_adj.make
	 lyapunov_pattern_adj.set_text(lyapunov_pattern)
	 table.attach2(lyapunov_pattern_adj, 1, 2, 5, 6)
	 lyapunov_pattern_adj.show
	 
	 vbox.pack_start(table, True, True, 0)
	 table.show
      end	 
   
feature -- attributes
   
   total, dump: INTEGER
   julia_x, julia_y: DOUBLE
   lyapunov_pattern: STRING
   total_adj, dump_adj: GTK_ADJUSTMENT
   julia_x_adj, julia_y_adj, lyapunov_pattern_adj: GTK_ENTRY
   
end -- NEW_PARAMS_DIALOG

